
#typedef HDC int
#typedef LONG int
#typedef ULONG unsigned int
#typedef HRESULT int
#typedef DWORD unsigned int
#typedef LONGLONG int64
#typedef ULONGLONG unsigned int64
#typedef COLORREF int
#typedef HBRUSH int
#typedef HWND int
#typedef HGDIOBJ int
#typedef OLE_XSIZE_HIMETRIC int
#typedef OLE_YSIZE_HIMETRIC int
#typedef OLE_XPOS_HIMETRIC int
#typedef OLE_YPOS_HIMETRIC int
#typedef HBITMAP int
#typedef HGLOBAL int
#typedef BOOL int
#typedef WINOLECTLAPI int
#typedef HANDLE int
#typedef LPCSTR pointer
#typedef LPCTSTR pointer
#typedef LPTHREAD_START_ROUTINE int
#typedef LPVOID pointer
#typedef SIZE_T int
#typedef HFILE int
#typedef HRSRC int
#typedef HMODULE int
#typedef char byte
#typedef PVOID pointer

#define STREAM_SEEK_SET 0
#define SRCCOPY 0x00CC0020
#define INVALID_HANDLE_VALUE -1
#define LOGPIXELSX 88
#define LOGPIXELSY 90
#define CREATE_SUSPENDED 0x00000004
#define GMEM_FIXED 0x0000
#define GMEM_MOVEABLE 0x0002 
#define GMEM_NODISCARD 0x0020
#define SWP_NOMOVE 0x0002
#define SWP_NOZORDER 0x0004
#define COLOR_3DFACE 15
#define COLOR_WINDOW 5


struct GUID {
    unsigned int   Data1;
    unsigned word Data2;
    unsigned word Data3;
    unsigned byte  Data4[ 8 ];
}
struct SIZE
{
    LONG cx;
    LONG cy;
}

extern _IID_IPicture as GUID;
extern _hinstance as int;

struct LARGE_INTEGER
{
    LONGLONG QuadPart[0];
        DWORD LowPart;
        LONG HighPart;
}


struct ULARGE_INTEGER
{
    ULONGLONG QuadPart[0];
    DWORD LowPart;
    DWORD HighPart;
}

struct PAINTSTRUCT {
    HDC         hdc;
    BOOL        fErase;
    RECT        rcPaint;
    BOOL        fRestore;
    BOOL        fIncUpdate;
    unsigned byte rgbReserved[32];
}

declare import,SetWindowText alias SetWindowTextW(HWND hWnd,opt LPCWSTR lpString),BOOL;
declare import,IsWindowVisible(HWND hWnd),BOOL;
declare import,GetClientRect(HWND hWnd, RECT *lpRect),BOOL;
declare import,CreateSolidBrush(COLORREF color),HBRUSH;
declare import,FillRect(HDC hDC,RECT *lprc, HBRUSH hbr),int;
declare import, DeleteObject(HGDIOBJ ho),BOOL;
declare import, SelectObject(HDC hdc, HGDIOBJ h),HGDIOBJ;
declare import, DeleteDC(HDC hdc),BOOL;
declare import,GetDC(opt HWND hWnd),HDC;
declare import, BitBlt(HDC hdc, int x, int y, int cx, int cy, HDC hdcSrc, int x1, int y1, DWORD rop),BOOL;
declare import,ReleaseDC(opt HWND hWnd,HDC hDC),int;
declare import, CreateStreamOnHGlobal (HGLOBAL hGlobal, BOOL fDeleteOnRelease,/*out*/IStream * ppstm),HRESULT;
declare import, OleLoadPicture(IStream *lpstream, LONG lSize, BOOL fRunmode,REFIID *riid, LPVOID *lplpvObj),WINOLECTLAPI;
import int cdecl strncmp(char *q, char *w, int e);
import int cdecl memcmp(void *a, void *b, int n);
#ifndef _INC_MATH
import double  cdecl pow(double d, double d);
#endif
declare import, CreateCompatibleDC(HDC hdc),HDC;
declare import, CreateCompatibleBitmap(HDC hdc, int cx, int cy),HBITMAP;
declare import,SetRect(RECT *lprc,int xLeft,int xTop,int xRight, int yBottom),BOOL;
declare import,CreateEvent alias CreateEventA(opt SECURITY_ATTRIBUTES *lpEventAttributes,BOOL bManualReset,BOOL bInitialState,opt LPCSTR lpName),HANDLE;
declare import,CloseHandle(HANDLE hObject),BOOL;
declare import,GlobalLock(HGLOBAL hMem),LPVOID;
declare import,GlobalUnlock(HGLOBAL hMem),BOOL;
declare import,CopyRect(RECT *lprcDst,RECT *lprcSrc),BOOL;
declare import,GlobalAlloc(UINT uFlags,SIZE_T dwBytes),HGLOBAL;
declare import,ResetEvent(HANDLE hEvent),BOOL;
declare import,WaitForSingleObject(HANDLE hHandle,DWORD dwMilliseconds),DWORD;
declare import,MoveMemory alias RtlMoveMemory(PVOID Destination,VOID* Source,SIZE_T Length);
declare import,GetSysColor(int nIndex),DWORD;
declare import,MulDiv(int nNumber,int nNumerator,int nDenominator),int; 
declare import, GetDeviceCaps(HDC hdc, int index),int;
declare import,GlobalFree(HGLOBAL hMem),HGLOBAL;
declare import,CreateThread(opt SECURITY_ATTRIBUTES *lpThreadAttributes,SIZE_T dwStackSize,LPTHREAD_START_ROUTINE lpStartAddress,opt LPVOID lpParameter,DWORD dwCreationFlags,/*out*/opt DWORD *lpThreadId),HANDLE; 
declare import,ResumeThread(HANDLE hThread),DWORD; 
declare import,FindResource alias FindResourceA(HMODULE hModule,LPCSTR lpName,LPCSTR lpType),HRSRC;
declare import,LoadResource(opt HMODULE hModule,HRSRC hResInfo),HGLOBAL;
declare import,SizeofResource(opt HMODULE hModule,HRSRC hResInfo),DWORD; 
declare import,FreeResource(HGLOBAL hResData),BOOL;
declare import,SetWindowPos(HWND hWnd,HWND hWndInsertAfter,int X,int Y,int cx,int cy,UINT uFlags),BOOL; 
declare import,LockResource(HGLOBAL hResData),LPVOID;
declare import,SetEvent(HANDLE hEvent),BOOL;
declare import,GetUpdateRect(HWND hWnd, RECT *lpRect,BOOL bErase),BOOL;
declare import,BeginPaint(HWND hWnd, PAINTSTRUCT *lpPaint),HDC;
declare import,EndPaint(HWND hWnd,PAINTSTRUCT *lpPaint),BOOL;

interface IUnknown
{
	declare virtual QueryInterface(REFIID *riid,/*out*/void *ppvObject),HRESULT;
	declare virtual AddRef(),ULONG;
	declare virtual Release(),ULONG;
}
interface ISequentialStream : IUnknown
{
	declare virtual Read(void *pv,ULONG cb,ULONG *pcbRead),HRESULT;
	declare virtual Write(void *pv,ULONG cb,ULONG *pcbWritten),HRESULT;
}

interface IStream : ISequentialStream
{
	declare virtual Seek(LARGE_INTEGER dlibMove byval,DWORD dwOrigin,ULARGE_INTEGER *plibNewPosition),HRESULT;
	declare virtual SetSize(ULARGE_INTEGER libNewSize byval),HRESULT;
	declare virtual CopyTo(IStream *pstm,ULARGE_INTEGER cb byval,ULARGE_INTEGER *pcbRead,ULARGE_INTEGER *pcbWritten),HRESULT;
	declare virtual Commit(DWORD grfCommitFlags),HRESULT;
	declare virtual Revert(),HRESULT;
	declare virtual LockRegion(ULARGE_INTEGER libOffset byval,ULARGE_INTEGER cb byval,DWORD dwLockType),HRESULT;
	declare virtual UnlockRegion(ULARGE_INTEGER libOffset byval,ULARGE_INTEGER cb byval,DWORD dwLockType),HRESULT;
	declare virtual Stat(STATSTG *pstatstg,DWORD grfStatFlag),HRESULT;
	declare virtual Clone(IStream *ppstm),HRESULT;
}

interface IPicture : IUnknown
{
	declare virtual get_Handle(OLE_HANDLE *pHandle),HRESULT;
	declare virtual get_hPal(OLE_HANDLE *phPal),HRESULT;
	declare virtual get_Type(SHORT *pType),HRESULT;
	declare virtual get_Width(OLE_XSIZE_HIMETRIC *pWidth),HRESULT;
	declare virtual get_Height(OLE_YSIZE_HIMETRIC *pHeight),HRESULT;
	declare virtual Render(HDC hDC,LONG x,LONG y,LONG cx,LONG cy,OLE_XPOS_HIMETRIC xSrc,OLE_YPOS_HIMETRIC ySrc,OLE_XSIZE_HIMETRIC cxSrc,OLE_YSIZE_HIMETRIC cySrc,RECT *pRcWBounds),HRESULT;
	declare virtual set_hPal(OLE_HANDLE hPal),HRESULT;
	declare virtual get_CurDC(/* [out] */ HDC *phDC),HRESULT;
	declare virtual SelectPicture(HDC hDCIn,HDC *phDCOut,OLE_HANDLE *phBmpOut),HRESULT;
	declare virtual get_KeepOriginalFormat( BOOL *pKeep),HRESULT;
	declare virtual put_KeepOriginalFormat(BOOL keep),HRESULT;
	declare virtual PictureChanged(),HRESULT;
	declare virtual SaveAsFile(BOOL fSaveMemCopy,LONG *pCbSize),HRESULT;
	declare virtual get_Attributes(DWORD *pDwAttr),HRESULT;
}
